#!/bin/bash

log_file=/linuxcash/logs/current/rndis.log
log () {
    log_dir=`dirname $log_file`
    [ -d $log_dir ] || mkdir -p $log_dir
    while read data; do
        echo "$(date +"%F %X.%3N") - $data" >> $log_file
    done
}
exec > >(log) 2>&1

echo "Старт сервиса проверки состояния интерфейсов RNDIS"

while true; do
    echo "Проверка состояния интерфейсов RNDIS"
    cd /sys/bus/usb/drivers/usb/
    devs=($(find -L ./usb*  -maxdepth 2 -type f -exec grep -H RNDIS {} \; 2>/dev/null | awk -F '/' {'print $3'}))
    devs_count=${#devs[@]}
    iface_count=`ifconfig | grep -c RNDIS`
    echo "Количество RNDIS устройств $devs_count, интерфейсов $iface_count"

    if [ "$devs_count" -gt "$iface_count" ]; then
        for dev in ${devs[@]}; do
            echo "Переподключение устройства /sys/bus/usb/drivers/usb/$dev"
            echo $dev > /sys/bus/usb/drivers/usb/unbind
            sleep 2
            echo $dev > /sys/bus/usb/drivers/usb/bind
        done
    fi

    echo "Проверка выполнена, следующая проверка через 10 минут"
    sleep 600
done
